use svg_filters::{
    types::nodes::{primitives::color_matrix::ColorMatrixType, standard_input::StandardInput},
    Edge, Filter, Node,
};

fn main() {
    let mut supersimple = Filter::new();

    let cm = supersimple.add_node(Node::color_matrix(ColorMatrixType::Matrix(Box::new([
        1., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 0.,
    ]))));

    supersimple
        .graph
        .extend_with_edges(&[(supersimple.source_graphic(), cm)]);
    dbg!(supersimple.to_svg());

    let mut filter = Filter::new();

    // <filter id="chromabb" >
    //   <feColorMatrix values="1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0" in="SourceGraphic" />
    //   <feOffset dx="25" dy="0" />
    //   <feGaussianBlur stdDeviation="5 0" result="red" />

    //   <feColorMatrix values="0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0" result="grn" in="SourceGraphic" />

    //   <feColorMatrix values="0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 0" in="SourceGraphic" />
    //   <feOffset dx="-25" dy="0" />
    //   <feGaussianBlur stdDeviation="5 0" result="blu"/>

    //   <feComposite in="red" in2="blu" operator="arithmetic" k2="1" k3="1" result="rb" />
    //   <feComposite in="rb" in2="grn" operator="arithmetic" k2="1" k3="1" />
    // </filter>

    let chan_r = filter.add_node(Node::color_matrix(ColorMatrixType::Matrix(Box::new([
        1., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 0.,
    ]))));
    let chan_g = filter.add_node(Node::color_matrix(ColorMatrixType::Matrix(Box::new([
        0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 0.,
    ]))));
    let chan_b = filter.add_node(Node::color_matrix(ColorMatrixType::Matrix(Box::new([
        0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 0., 0., 1., 0.,
    ]))));

    let offset_r = filter.add_node(Node::offset(25., 0.));
    let offset_b = filter.add_node(Node::offset(-25., 0.));
    let blur_r = filter.add_node(Node::gaussian_blur_xy(5, 0));
    let blur_b = filter.add_node(Node::gaussian_blur_xy(5, 0));

    let composite_rb = filter.add_node(Node::composite_arithmetic(0., 1., 1., 0.));
    let composite_final = filter.add_node(Node::composite_arithmetic(0., 1., 1., 0.));

    filter.graph.extend_with_edges(&[
        (filter.source_graphic(), chan_r, Edge::new()),
        (filter.source_graphic(), chan_b, Edge::new()),
        (filter.source_graphic(), chan_g, Edge::new()),
        (chan_r, offset_r, Edge::new()),
        (offset_r, blur_r, Edge::new()),
        (chan_b, offset_b, Edge::new()),
        (offset_b, blur_b, Edge::new()),
        (blur_r, composite_rb, Edge::in_idx(0)),
        (blur_b, composite_rb, Edge::in_idx(1)),
        (composite_rb, composite_final, Edge::in_idx(0)),
        (chan_g, composite_final, Edge::in_idx(1)),
    ]);

    println!("Result: {}", filter.to_svg())
}
