/// [feComposite](https://www.w3.org/TR/SVG11/filters.html#feCompositeElement)
#[derive(Debug)]
pub struct Composite {
    operator: CompositeOperator,
}

impl Composite {
    pub fn new(op: CompositeOperator) -> Self {
        Self { operator: op }
    }

    pub fn arithmetic(k1: f32, k2: f32, k3: f32, k4: f32) -> Self {
        Self {
            operator: CompositeOperator::Arithmetic { k1, k2, k3, k4 },
        }
    }
}

#[derive(Debug)]
pub enum CompositeOperator {
    Over,
    In,
    Out,
    Atop,
    Xor,
    Arithmetic { k1: f32, k2: f32, k3: f32, k4: f32 },
}
