/// [feGaussianBlur](https://www.w3.org/TR/SVG11/filters.html#feGaussianBlurElement)
#[derive(Debug)]
pub struct GaussianBlur {
    std_deviation: (u16, u16),
}

impl GaussianBlur {
    pub fn single(v: u16) -> Self {
        Self {
            std_deviation: (v, v),
        }
    }

    pub fn with_xy(x: u16, y: u16) -> Self {
        Self {
            std_deviation: (x, y),
        }
    }
}
